<template lang="pug">
component.btn.is-flex( :class='[`is-${type}`, { "fullwidth": fullwidth }]' :is='as' :to='to' @click='handleClick' )
	.wrapper-content.is-flex-grow-1.is-flex.is-align-items-center.is-justify-content-center
		p
			slot
	.wrapper-icon.is-flex.is-align-items-center.is-justify-content-center
		.img.is-flex.is-justify-content-center
			component( :is='img' )
</template>

<script>
export default {
	props: {
		type: {
			type: String,
			default: "primary",
			validator: val => [ "primary", "link", "orange" ].includes(val)
		},
		asset: {
			type: String,
			default: "angle_right"
		},
		as: {
			default: "div",
			validator: val => [ "a", "div", "router-link", "button" ].includes(val)
		},
		to: [ String, Object ],
		fullwidth: Boolean
	},
	computed: {
		img() {
			let asset = this.asset
			return () => import(`svg/${asset}.svg`)
		}
	},
	methods: {
		handleClick() {
			this.$emit("click")
		}
	}
}
</script>

<style lang="scss" scoped>
.btn {
	height: 2.5rem;
	cursor: pointer;
	&.fullwidth {
		width: 100%;
		.wrapper {
			&-content {
				flex: 1;
			}
		}
	}

	@include tablet {
		height: 2.125rem;
	}
}

.wrapper {
	&-content {
		font-weight: 600;
		color: #fff;
		padding: 0 1.5rem;
		border: 2px solid rgba($color: #fff, $alpha: .19);
		border-right: unset;
		border-top-left-radius: 50px;
		border-bottom-left-radius: 50px;
		transition: all .2s ease-in-out;
		p {
			font-size: .75rem;
		}
		@include max_tablet {
			padding: 0 .75rem;
			p {
				font-size: .6875rem;
			}
		}
	}
	&-icon {
		padding: 0 1.25rem 0 1rem;
		background: $grey-dark;
		border: 2px solid;
		border-left: unset;
		border-top-right-radius: 50px;
		border-bottom-right-radius: 50px;
		transition: all .2s ease-in-out;
		.img {
			width: .875rem;
			@include mobile {
				width: .75rem;
			}
		}
		svg::v-deep {
			transition: all .2s ease-in-out;
			path {
				transition: all .2s ease-in-out;
			}
		}
		@include tablet {
			padding: 0 .75rem 0 .5rem;
		}
	}
}

$types: (
	"primary": (
		$primary
	),
	"link": (
		$link
	),
	"orange": (
		$orange
	)
);

@each $type, $colors in $types {
	$color: nth($colors, 1);

	.is-#{$type} {
		.wrapper-icon {
			border-color: $color;
			@if $type == "link" {
				svg::v-deep {
					path {
						fill: $color;
					}
				}
			}
		}
		&:hover {
			@if $type == "link" {
				.wrapper {
					&-content {
						background: $color;
						border-color: $color;
					}
					&-icon {
						background: #000;
						border-color: #000;
					}
				}
			}
			@else {
				.wrapper {
					&-content {
						border-color: $color;
						p {
							color: $color;
						}
					}
					&-icon {
						background: #000;
					}
				}
			}
		}
	}
}
</style>